#include "dispatchers.h"

#include "logging.h"

Dispatch::Dispatch(Session &s) : sess{s} {};

Dispatch::~Dispatch() {};

// virtuals
/*
void Dispatch::server_line(const std::string &line){};
void Dispatch::server_prompt(const std::string &prompt){};
void Dispatch::client_input(const std::string &input){};
*/

void Dispatch::to_server(const std::string &send) { sess.to_server(send); }
void Dispatch::to_client(const std::string &send) { sess.to_client(send); }
const std::string &Dispatch::get_prompt(void) { return sess.get_prompt(); }

CoreDispatch::CoreDispatch(Session &s) : Dispatch{s} {
    BUGZ_LOG(warning) << "CoreDispatch()";
}

void CoreDispatch::server_line(const std::string &line) {}
void CoreDispatch::server_prompt(const std::string &prompt) {}
void CoreDispatch::client_input(const std::string &input) {
    BUGZ_LOG(warning) << "Got: " << input << " prompt=" << get_prompt();
}
